`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/05/06 15:40:14
// Design Name: 
// Module Name: calculate
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module calculate(
    input clk,
    input rst,
    input [1:0] calculate_state,
    input press,
    input  [3:0] a1,
    input  [3:0] a2,
    input  [3:0] b1,
    input  [3:0] b2,
    output reg [3:0] result1,
    output reg [3:0] result2,
    output reg [3:0] result3,
    output reg [3:0] result4
    );
    reg [3:0] result1_tmp;
    reg [3:0] result2_tmp;
    reg [3:0] result3_tmp;
    reg [3:0] result4_tmp;
    
    always@*
    case(calculate_state)
    2'b00: // +
    begin
        result4_tmp = 4'b0000;
        result3_tmp = (a1 * 10 + a2 + b1 * 10 + b2) / 100;
        result2_tmp = ((a1 * 10 + a2 + b1 * 10 + b2) - result3_tmp * 100) / 10;
        result1_tmp = (a1 * 10 + a2 + b1 * 10 + b2) - result3_tmp * 100 - result2_tmp * 10;
    end
    2'b01:
        if({a1,a2}>={b1,b2})
            if(a2>=b2) begin
                result4_tmp = 4'b0000;
                result3_tmp = 4'b0000;
                result2_tmp = a1 - b1;
                result1_tmp = a2 - b2;
            end
            else begin
                result4_tmp = 4'b0000;
                result3_tmp = 4'b0000;
                result2_tmp = a1 - b1 - 1'b1;
                result1_tmp = 4'b1010 + a2 - b2;
            end
        else
            if(b2>=a2) begin
                result4_tmp = 4'b0000;
                result3_tmp = 4'b1010;
                result2_tmp = b1 - a1;
                result1_tmp = b2 - a2;
            end
            else begin
                result4_tmp = 4'b0000;
                result3_tmp = 4'b1010;
                result2_tmp = b1 - a1 - 1'b1;
                result1_tmp = 4'b1010 + b2 - a2;
            end
    2'b10: // *
    begin
        result4_tmp = (a1 * 10 + a2) * (b1 * 10 + b2) / 1000;
        result3_tmp = ((a1 * 10 + a2) * (b1 * 10 + b2) - result4_tmp * 1000) / 100;
        result2_tmp = ((a1 * 10 + a2) * (b1 * 10 + b2) - result4_tmp * 1000 - result3_tmp * 100) / 10;
        result1_tmp = (a1 * 10 + a2) * (b1 * 10 + b2) - result4_tmp * 1000 - result3_tmp * 100 - result2_tmp * 10;
    end
    endcase
    
    always@(posedge clk or posedge rst)
    if(rst)
    begin
        result1 <= 4'b0000;
        result2 <= 4'b0000;
        result3 <= 4'b0000;
        result4 <= 4'b0000;
    end
    else
    begin
        result1 <= result1_tmp;
        result2 <= result2_tmp;
        result3 <= result3_tmp;
        result4 <= result4_tmp;
    end
endmodule
