`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/05/05 16:13:10
// Design Name: 
// Module Name: ssd_change
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module ssd_change(
    input clk,
    input rst,
    input [8:0] last_change,
    input press,
    input show,
    output reg [3:0] a1,
    output reg [3:0] a2,
    output reg [3:0] b1,
    output reg [3:0] b2
    );
    reg [1:0] ssd_state;
    reg [3:0] number;
    reg [1:0] next_state;
    reg [3:0] a1_tmp;
    reg [3:0] a2_tmp;
    reg [3:0] b1_tmp;
    reg [3:0] b2_tmp;
    
    always@*
    case(last_change)
        9'h70: begin
            number = 4'b0000;
         //   next_state = ssd_state + 1'b1;
        end
        9'h69: begin
            number = 4'b0001;
         //   next_state = ssd_state + 1'b1;
        end
        9'h72: begin
            number = 4'b0010;
          //  next_state = ssd_state + 1'b1;
        end
        9'h7A: begin
            number = 4'b0011;
          //  next_state = ssd_state + 1'b1;
        end
        9'h6B: begin
            number = 4'b0100;
          //  next_state = ssd_state + 1'b1;
        end
        9'h73: begin
            number = 4'b0101;
          //  next_state = ssd_state + 1'b1;
        end
        9'h74: begin
            number = 4'b0110;
          //  next_state = ssd_state + 1'b1;
        end
        9'h6C: begin
            number = 4'b0111;
          //  next_state = ssd_state + 1'b1;
        end
        9'h75: begin
            number = 4'b1000;
          //  next_state = ssd_state + 1'b1;
        end
        9'h7D: begin
            number = 4'b1001;
         //   next_state = ssd_state + 1'b1;
        end
        default: begin
            number = number;
           // next_state = ssd_state;
        end
    endcase
    
    always@(posedge clk or posedge rst)
    if(rst)
        ssd_state <= 2'b00;
    else
        ssd_state <= next_state;
    
    always@(negedge press)
    case(last_change)
        9'h70, 9'h69, 9'h72, 9'h7A, 9'h6B, 9'h73, 9'h74, 9'h6C, 9'h75, 9'h7D:
            next_state = ssd_state + 1'b1;
        default:
            next_state = ssd_state;
    endcase
    
    always@(posedge press)
    if((last_change==9'h79) || (last_change==9'h7B) || (last_change==9'h7C) || (last_change==9'h5A) || show == 1)
        begin
            a1_tmp = a1;
            a2_tmp = a2;
            b1_tmp = b1;
            b2_tmp = b2;
        //   next_state = ssd_state;
        end
    else
        case(ssd_state)
        2'b00: begin
            a1_tmp = number;
            a2_tmp = a2;
            b1_tmp = b1;
            b2_tmp = b2;
          //  next_state = ssd_state + 1'b1;
        end
        2'b01: begin
            a1_tmp = a1;
            a2_tmp = number;
            b1_tmp = b1;
            b2_tmp = b2;
          //  next_state = ssd_state + 1'b1;
        end
        2'b10: begin
            a1_tmp = a1;
            a2_tmp = a2;
            b1_tmp = number;
            b2_tmp = b2;
         //   next_state = ssd_state + 1'b1;
        end
        2'b11: begin
            a1_tmp = a1;
            a2_tmp = a2;
            b1_tmp = b1;
            b2_tmp = number;
        //    next_state = ssd_state + 1'b1;
        end
        default: begin
            a1_tmp = a1;
            a2_tmp = a2;
            b1_tmp = b1;
            b2_tmp = b2;
          //  next_state = ssd_state;
        end
        endcase
    
    always@(posedge clk or posedge rst)
    if(rst)
    begin
        a1 <= 4'b0000;
        a2 <= 4'b0000;
        b1 <= 4'b0000;
        b2 <= 4'b0000;
    end
    else
    begin
        a1 <= a1_tmp;
        a2 <= a2_tmp;
        b1 <= b1_tmp;
        b2 <= b2_tmp;
    end
    
endmodule
