`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/05/06 17:41:10
// Design Name: 
// Module Name: top_module
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module top_module(
    input clk,
    input rst,
    inout PS2_DATA,
    inout PS2_CLK,
    output [3:0] ssd_ctl,
    output [7:0] segs,
    output reg [3:0] LED
    );
    wire [8:0] last_change;
    wire [511:0] key_down;
    wire key_valid;
    wire clk_100Hz;
    wire [1:0] ssd_ctl_en;
    wire press;
    wire [1:0] calculate_state;
    wire show;
    wire [3:0] a1;
    wire [3:0] a2;
    wire [3:0] b1;
    wire [3:0] b2;
    wire [3:0] result1;
    wire [3:0] result2;
    wire [3:0] result3;
    wire [3:0] result4;
    wire [3:0] out1;
    wire [3:0] out2;
    wire [3:0] out3;
    wire [3:0] out4;
    wire [3:0] ssd_in;
        
    KeyboardDecoder U0(.clk(clk),.rst(rst),.PS2_DATA(PS2_DATA),.PS2_CLK(PS2_CLK)
                        ,.last_change(last_change),.key_down(key_down),.key_valid(key_valid));
    freqdiv U1(.clk(clk),.rst(rst),.clk_100Hz(clk_100Hz),.ssd_ctl_en(ssd_ctl_en));
    press_state U2(.clk(clk_100Hz),.rst(rst),.key_valid(key_valid),.press_state(press));
    calculate_state U3(.clk(clk_100Hz),.rst(rst),.last_change(last_change),.calculate_state(calculate_state));
    show_input U4(.clk(clk),.rst(rst),.last_change(last_change),.press(press),.show(show));
    ssd_change U5(.clk(clk_100Hz),.rst(rst),.last_change(last_change),.press(press),.show(show),.a1(a1),.a2(a2),.b1(b1),.b2(b2));
    calculate U6(.clk(clk_100Hz),.rst(rst),.press(press),.calculate_state(calculate_state)
                 ,.a1(a1),.a2(a2),.b1(b1),.b2(b2),.result1(result1),.result2(result2),.result3(result3),.result4(result4));
    mode U7(.show(show),.a1(a1),.a2(a2),.b1(b1),.b2(b2),.result1(result1),.result2(result2),.result3(result3),.result4(result4)
            ,.out1(out1),.out2(out2),.out3(out3),.out4(out4));
    scan_ctl U8(.out1(out1),.out2(out2),.out3(out3),.out4(out4),.ssd_ctl_en(ssd_ctl_en),.ssd_in(ssd_in),.ssd_ctl(ssd_ctl));
    display U9(.i(ssd_in),.D(segs));
    
    always@*
    case(calculate_state)
    2'b00:
        LED[2:0] = 3'b001;
    2'b01:
        LED[2:0] = 3'b010;
    2'b10:
        LED[2:0] = 3'b100;
    default:
        LED[2:0] = 3'b000;
    endcase
    
     always@*
     if(show)
        LED[3] = 1'b1;
     else
        LED[3] = 1'b0;
    
endmodule
